/*
 * 
 */
package casa.JION.entry;

import java.io.IOException;
//import java.util.Date;
import java.util.Iterator;
import java.util.Map;

import casa.JION.configuration.Configuration;
import casa.dodwan.docware.Descriptor;

// TODO: Auto-generated Javadoc
/**
 * This class is the supertype of all entries that can be stored in a
 * Jini(TM) Lookup service.
 * <p>
 * Each field of an entry must be a public reference (object) type.
 * You cannot store primitive types in fields of an
 * <code>Entry</code>.  An <code>Entry</code> may have any number of
 * methods or constructors.  Each field is serialized separately, so
 * references between two fields of an entry will not be reconstituted
 * to be shared references, but instead to separate copies of the
 * original object.
 *
 * @author Sun Microsystems, Inc.
 *
 *
 * @since 1.0
 */
public class Entry extends casa.dodwan.message.Message implements net.jini.core.entry.Entry {

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 1L;
//	private Lease lease=null;
	/**
 * Instantiates a new entry.
 */
public Entry(){
		super();
		super.setDescriptor(new casa.dodwan.docware.Descriptor());
		super.setPayload("TupleSpace".getBytes());
	}
	
	/**
	 * Instantiates a new entry.
	 *
	 * @param desc the desc
	 */
	public Entry (Descriptor desc){
		super();
		super.setDescriptor(desc);
		super.setPayload("".getBytes());
		
	}
	
	/**
	 * This function could be used only with Javaspace.write() function
	 *
	 * @param arg0 the arg0
	 * @param arg1 the arg1
	 */
//	private void setLease(Lease lease){
//		this.lease=lease;
//		this.getDescriptor().setDeadline(new Date(lease.getExpiration()));
//	}
//	
//	public Lease getLease(){
//		return lease;
//	}
	
	public void addField(String arg0, String arg1){
		if (arg1==null||arg1.equalsIgnoreCase("null"))
			arg1=".*";
		getDescriptor().setAttribute(arg0,arg1);
		
	}
	

	/**
	 * @see java.lang.Object#toString()
	 */
	public String toString(){
		StringBuffer string=new StringBuffer();
		String offset="   ";
		Descriptor desc =this.getDescriptor(); 
		if (desc !=null) {
			string.append("Entry Fields:\n");
			Iterator<Map.Entry<String, String>> it = desc.getEntrySet().iterator();
			while (it.hasNext()) {
				String field=it.next().toString();
				String[] attributes=field.split("=");
				if (attributes[1].equalsIgnoreCase(".*")){
					field=attributes[0]+"=null";
				}
				string.append(offset + field + "\n");
			}
		}
//		byte[] payload = this.getPayload();
//		if (!payload=="".getBytes()) {
//			string.append("Entry Payload:\n");
//			string.append(offset + new String(this.getPayload()).trim());
//		}
		return string.toString();
	}
	
	/**
 * Write object.
 *
 * @param out the out
 * @throws IOException Signals that an I/O exception has occurred.
 */
private void writeObject(java.io.ObjectOutputStream out) throws IOException {
//		out.defaultWriteObject();
		out.writeObject(getDescriptor());
		out.writeObject(getPayload());
	}
	
	/**
	 * Read object.
	 *
	 * @param in the in
	 * @throws IOException Signals that an I/O exception has occurred.
	 * @throws ClassNotFoundException the class not found exception
	 */
	private void readObject(java.io.ObjectInputStream in) throws IOException, ClassNotFoundException{
//		in.defaultReadObject();
		Descriptor desc=(Descriptor) in.readObject();
		byte[] payload = (byte[]) in.readObject();
		setDescriptor(desc);
		setPayload(payload);
		
	}
	
	/**
	 * Matches.
	 *
	 * @param entry the entry
	 * @return true, if successful
	 */
	public boolean matches(Entry entry){
		return this.getDescriptor().matches(entry.getDescriptor());
	}
	
	/**
	 * The main method.
	 *
	 * @param args the arguments
	 */
	public static void main (String [] args){
		Entry entry=new Entry();
		entry.addField("name", null);
		entry.addField("age", "28");
		Entry template= new Entry();
		template.addField("name", null);
		System.out.println(entry);
		System.out.println(Configuration.immutatedTuple);
		
	}
}
