/*
 * 
 */
package casa.JION.manager;

import java.io.File;
import java.util.Date;
import java.util.HashMap;

import casa.JION.entry.Entry;
import casa.JION.utile.DodwanSingleton;
import casa.dodwan.docware.Descriptor;
import casa.dodwan.docware.DescriptorZipBufferizer;
import casa.dodwan.message.Message;
import casa.dodwan.run.Dodwan;
import casa.dodwan.util.FileBasedRepository;

// TODO: Auto-generated Javadoc
/**
 * The Class Manager.
 */
public class Manager {
	
	/** The map. */
	public static HashMap<String, Object> map=null;
	
	/** The dodwan. */
	private Dodwan dodwan=null;
	
	/** The operation file. */
	private File operationFile=null;
	
	/** The operation dir. */
	private FileBasedRepository<Descriptor> operationDir=null;
	
	/** The space file. */
	private File spaceFile=null;
	
	/** The space dir. */
	private FileBasedRepository<Descriptor> spaceDir=null;
	
	/**
	 * Instantiates a new manager.
	 */
	protected Manager(){
		spaceFile= new File("space");
		spaceDir= new FileBasedRepository<Descriptor>(spaceFile, new DescriptorZipBufferizer());
		dodwan=DodwanSingleton.getDodwan();
		if (! dodwan.pubSubService.getKeys().contains("TupleSpace")){
			Descriptor pattern=new Descriptor();
			pattern.setAttribute("fetch", "operation");
//			dodwan.pubSubService.addSubscription("TupleSpace", pattern, new MyProcessor());
		}
		map= new HashMap<String, Object>();
		operationFile=new File("operation");
		operationDir= new FileBasedRepository<Descriptor>(operationFile, new DescriptorZipBufferizer());
			
	}
	
	/**
	 * Checkup.
	 *
	 * @param message the message
	 */
	public void checkup(Message message){
		outOffDate();
	}
	
	/**
	 * Out off date.
	 */
	public void outOffDate(){
		Date now = new Date(System.currentTimeMillis());
		Date temp=null;
		for(File x: spaceFile.listFiles()){
			temp=spaceDir.get(x.getName()).getDeadline();
			if (temp!=null&&now.compareTo(temp)>0){
				if (x.delete())
					System.out.println(x.getName()+" has been deleted");
			}
		}
		for(File x: operationFile.listFiles()){
			temp= operationDir.get(x.getName()).getDeadline();
			if (temp!=null&&now.compareTo(temp)>0){
				if (x.delete())
					System.out.println(x.getName()+" has been deleted");		
			}
		}
	}
	
	/**
	 * Adds the operation.
	 *
	 * @param tmpl the tmpl
	 * @param lock the lock
	 * @throws IllegalArgumentException the illegal argument exception
	 */
	public void addOperation(Entry tmpl, Object lock) throws IllegalArgumentException{
		String id= lock.toString();
		if (tmpl==null || id==null)
			throw new IllegalArgumentException("Problems is adding operations");
		map.put(id, lock);
		operationDir.put(id, tmpl.getDescriptor());
	}
	
	/**
	 * The main method.
	 *
	 * @param args the arguments
	 */
	public static void main(String [] args){
		Manager manager= new Manager();
		Entry template = new Entry();
		template.getDescriptor().setDeadline(new Date(System.currentTimeMillis()+40000));
		template.addField("RID", "kiko2");
		template.addField("SELECTOR", "h=r");
//		manager.addOperation(template);
		manager.outOffDate();
	}
	
}
